#include<stdio.h>
#include<string.h>
#include<errno.h>
#include<unistd.h>
#include<sys/types.h>
#include<sys/syslimits.h>
#include<signal.h>
#include<X11/Intrinsic.h>
#include<X11/StringDefs.h>
#include<X11/Xaw/Form.h>
#include<X11/Xaw/Viewport.h>
#include<X11/Xaw/Label.h>
#include<X11/Shell.h>
#include<X11/xpm.h>

#include"xjump.h"
#include"xjump_xlib.h"
#include"record.h"

#include"picture.xpm"
#include"icon.xbm"
#include"icon_msk.xbm"

#define TITLE 0
#define GAME  1
#define OVER  2

#define SHOW_TOTAL	0
#define SHOW_PRIVATE	1
#define SHOW_REPLAY	2

#define SPEED 20

#define NUM_LOG	8

extern char *DefaultResources[];

static XtAppContext App;   /* ץꥱ󥳥ƥ */

static Widget
       Top,              /* Ǿ                        */
       Score,            /* (٥)                */
       Scr,              /* ᥤ̡ʥ)             */
       Score_v,          /* ϥ(ӥ塼ݡ)      */
       ScoreList,        /* ϥ(٥)            */
       Gameover,         /* ४С(٥)        */
       Pause,            /* ݡ(٥)                */
       Message;		/* message/Label */



static Colormap Cmap;    /* 顼ޥå */

static int IntervalState;       /* ޽? */
static XtIntervalId IntervalId; /* ޡΣɣ */

static char *GraphFile = NULL;     /* 桼եåե */

static int GameMode; /* ⡼ (0ȥ  1  2४С 3ݡ) */

static int ScoreMode;

static int Sc_now;

#if RECORD_ENTRY > RECORD_ENTRY_PRIVATE
#	if RECORD_ENTRY > NUM_LOG
#		define LINE	RECORD_ENTRY
#	else
#		define LINE	NUM_LOG
#	endif	
#else
#	if RECORD_ENTRY_PRIVATE > NUM_LOG
#		define LINE	RECORD_ENTRY_PRIVATE
#	else
#		define LINE	NUM_LOG
#	endif
#endif		

static char Score_list[43*(LINE+2)+2]="";    /* ϥƥ */

static XKeyboardState Keyboard;  /* ܡɥơ */
static int Repeat_mode = 1;      /* ԡȤξ(1:default 0:off) */

static int Key;			/* Keyboard vector */
static int Replay;

static log_t Log[8];
static int Log_cur;


/* ץȥ */

static void timi( XtPointer c, XtIntervalId id );


/* Хѿ */

Display *Disp;           /* ǥץ쥤¤ */

GC Gc_nomask;            /* GC (ޥ̵) */
GC Gc_mask;              /* GC (ޥ) */

Drawable Scr_d;          /* ᥤ */
Pixmap Char_p;           /* 饯 */
Pixmap Char_m;           /* 饯(ޥ) */
Pixmap Floor_p[4];       /*  */
Pixmap Back_p;           /* ط */

static record_file_t Record;
static record_file_t Record_private;

static record_t My_record;
static int Recording;

static char Filename[3][PATH_MAX+1];

char *Myname;   /* ץ̾ */


/*
** message 
*/

static void message( char *msg )
{
	XtVaSetValues(Message,XtNlabel,msg,NULL);
}

/*
** error
*/

static void error(void)
{
	char *str;
	char buf[64];

	str = strerror(errno);
	fprintf(stderr,"%s: %s\n",Myname,str);
	strcpy(buf,"Error: ");
	strncat(buf,str,63-7);
	message(buf);
}

/* ԡȤߤ */

static void repeat_off( void )
{
  if( Repeat_mode ){
    XGetKeyboardControl( Disp,&Keyboard );
    XAutoRepeatOff( Disp );
    Repeat_mode = 0;
  }
}


/* ԡȤ򸵤᤹ */

static void repeat_on( void )
{
  if( !Repeat_mode ){
    if( Keyboard.global_auto_repeat )
      XAutoRepeatOn( Disp );
    else
      XAutoRepeatOff( Disp );

    Repeat_mode = 1;
  }
}


/* ɽ */

static void put_score( void )
{
  char buf[4];

  sprintf( buf,"%03d",Sc_now );
  XtVaSetValues( Score,XtNlabel,buf,NULL );
}

static void make_replay( void )
{
  int i,j;
  char *p;

  p = Score_list;

  p += sprintf( p, "<< Push [1]-[8] to view Replay >>\n\nNo  Floor Size Date\n--- ----- ---- --------------------------\n");

  for( i = 1 ; i <= NUM_LOG ; i++ ){
    j = (Log_cur - i + NUM_LOG) % NUM_LOG;
    if( Log[j].floor == 0 )
      break;
    p += sprintf(p,"[%d] %5d %4d %s",i,Log[j].floor,Log[j].size,ctime(&Log[j].time));
  }
  p--;
  *p = '\0';

  XtVaSetValues( ScoreList,
		XtNlabel,Score_list,
		NULL );
}

/* ϥ̺ */

static void make_score(void)
{
  int i,num;
  char *p;
  record_t *q;
  char *title;

  if( ScoreMode == SHOW_REPLAY ){
    make_replay();
    return;
  }
  if( !Recording ){
    XtVaSetValues( ScoreList,
		XtNlabel,"Cannot save record file!",
		NULL );
    return;
  }

  if( ScoreMode == SHOW_TOTAL ){
    q = Record.record;
    num = Record.num_record;
    title = "Total Hi-Score Ranking";
  }else{
    q = Record_private.record;
    num = Record_private.num_record;
    title = "Your Hi-Score list";
  }
    

  p = Score_list;

  p += sprintf( p,"<< %s >>\n\nRANK FLOOR   NAME\n\
---- ----- -------------------------------\n",title);

  for( i = 0 ; i < num ; i++,q++ )
    p += sprintf( p,"%4d  %3d  %-31.31s\n", i+1, q->score, q->name);

  p--;
  *p = '\0';

  XtVaSetValues( ScoreList,
		XtNlabel,Score_list,
		NULL );
}



/* ޡ */

static void reset_timer( void )
{
  if( IntervalState ){
    XtRemoveTimeOut( IntervalId );
    IntervalState = 0;
  }
}


/* ޡ */

static void set_timer( void )
{
  if( IntervalState )
    reset_timer();
  IntervalId = XtAppAddTimeOut( App, SPEED ,(XtTimerCallbackProc)timi,NULL );
  IntervalState = 1;
}


/* ४С */

static void gameover( void )
{
  XtMapWidget( Gameover );

  GameMode = OVER;

  if( Replay ){
    message("");
    srnd(time(NULL));
    return;
  }

  if( Recording ){
    XFlush(Disp);
    My_record.score = Sc_now;
    My_record.date = time(NULL);
    if( RECORD_write(&Record) < 0 || RECORD_write(&Record_private) < 0 ){
      error();
      Recording = 0;
    }
    make_score();
  }

}


/* ȥ */

static void title( void )
{
  reset_timer();
  XtUnmapWidget( Gameover );
  XtUnmapWidget( Scr );
  GameMode = TITLE;
  make_score();
  XtMapWidget( Score_v );
}



/* ޡ롼 */

static void timi( XtPointer c,XtIntervalId id )
{
  int floor;
  static int timer;
  int i;
  int k;

  IntervalState = 0;

  set_timer();

  switch( GameMode ){
  case GAME:
    if( Replay ){
      k = LOG_read();
    }else{
      k = Key;
      LOG_write(Key);
    }
    floor = GAME_main(k);
    if( floor < 0 ){
      if( !Replay ){
        Log[Log_cur].size = LOG_write(-1);
        Log[Log_cur].floor = Sc_now;
	Log[Log_cur].time = time(NULL);
        for( i = 0 ; i < NUM_LOG ; i++ )
          LOG_check_broken(&Log[i]);
        Log_cur = (Log_cur + 1) % NUM_LOG;
      }

      gameover();
      timer = 0;
    }
    else if( floor > Sc_now ){
      Sc_now = floor;
      if( Sc_now > 999 )
	Sc_now = 999;
      put_score();
    }
    break;
    
  case OVER:
    if( ++timer > 250 )
      title();
    break;
  }
}


/* եѹ(ԡȤؤ)(٥ȥϥɥ) */

static void focus( Widget w,XtPointer p,XEvent *e )
{
  if( e->type == FocusIn )
    repeat_off();
  else
    repeat_on();
}


#if 0
/* ݡ (٥ȥϥɥ) */

static void expose( Widget w,XtPointer p,XEvent *e )
{
  recover_scr( e->xexpose.x,e->xexpose.y,
	      e->xexpose.width,e->xexpose.height );
}
#endif

/* ץཪλ (ϥɥ) */

static void quit_game( Widget w,XEvent *e,String *s,Cardinal *num )
{
  repeat_on();
  XFlush( Disp );
  exit(0);
}


/* ץཪλ(ʥϥɥ) */

static void sig_handler( int i )
{
  repeat_on();
  XFlush( Disp );
  exit(0);
}


/*  (ϥɥ) */

static void start_game( Widget w,XEvent *e,String *s,Cardinal *num )
{
  int level;
  int seed;
  int i;

  switch( GameMode ){
  case TITLE:
    if( *num > 1 && (i = atoi(s[1])) ){
      i = (Log_cur - i + NUM_LOG) % NUM_LOG;
      if( i < 0 || i >= NUM_LOG || Log[i].floor == 0 )
        break;
      level = Log[i].level;
      seed = Log[i].seed;
      LOG_start_read(&Log[i]);
      Replay = 1;
      message("Replay mode");
    }else{
      level = *num > 0 ? atoi(s[0]) : 0;
      seed = rnd(0x10000000);
      Log[Log_cur].seed = seed;
      Log[Log_cur].level = level;
      LOG_start_write(&Log[Log_cur]);
      Replay = 0;
      message("");
    }
    srnd(seed);

    XtUnmapWidget( Score_v );
    XtUnmapWidget( Gameover );
    reset_timer();
    XtMapWidget( Scr );
    GAME_init(level);
    Sc_now = 0;
    GameMode = GAME;
    Key &= ~KEY_UP;

    set_timer();
    break;

  case OVER:
    title();
    break;
  }
}


/* ݡ (ϥɥ) */

static void pause_game( Widget w,XEvent *e,String *s,Cardinal *num )
{
  if( GameMode == 1 ){
    reset_timer();
    XtMapWidget( Pause );
    GameMode = 3;
  }else if( GameMode == 3 ){
    GameMode = 1;
    XtUnmapWidget( Pause );
    set_timer();
  }
}



/* 줿(ϥɥ) */

static void key_on( Widget w,XEvent *e,String *s,Cardinal *num )
{
  switch( **s ){
  case 'U':
    Key |= KEY_UP;
    break;
  case 'R':
    Key |= KEY_RIGHT;
    break;
  case 'L':
    Key |= KEY_LEFT;
    break;
  }
}

/* Υ줿 (ϥɥ) */

static void key_off( Widget w,XEvent *e,String *s,Cardinal *num )
{
  switch( **s ){
  case 'U':
    Key &= ~KEY_UP;
    break;
  case 'R':
    Key &= ~KEY_RIGHT;
    break;
  case 'L':
    Key &= ~KEY_LEFT;
    break;
  }
}


static void show_record( Widget w,XEvent *e,String *s,Cardinal *num )
{
  if( GameMode != TITLE )
    return;

  ScoreMode = (ScoreMode+1) % 3;

  make_score();
}

/*  */

static void set_icon( void )
{
  Pixmap icon,mask;

  icon = XCreateBitmapFromData( Disp,DefaultRootWindow(Disp),icon_bits,
			       icon_width,icon_height );

  mask = XCreateBitmapFromData( Disp,DefaultRootWindow(Disp),icon_msk_bits,
			       icon_msk_width,icon_msk_height );

  XtVaSetValues( Top,XtNiconPixmap,icon,XtNiconMask,mask,NULL );
}


/* إ */

static void help()
{
  fprintf( stderr,"Usage: %s [options]\n",Myname );
  fprintf( stderr,"\t-toolkitoption ...\n" );
  fprintf( stderr,"\t-private\t\tuse private colormap.\n" );
  fprintf( stderr,"\t-graphic \"file\"\t\tuse your xpm graphic \"file\"\n" );
  fprintf( stderr,"\t-keymap\t\t\tread keymap directly.\n" );
  fprintf( stderr,"\t-help\t\t\tshow this messages.\n" );
}


/* ޥɥ饤󥪥ץ */

static void option( int argc, char **argv )
{
  int i;

  for( i = 1 ; i < argc ; i++ ){

    if( strcmp( argv[i],"-private" ) == 0 ){
      Cmap =
	XCreateColormap( Disp,DefaultRootWindow(Disp),
			DefaultVisual(Disp,DefaultScreen(Disp)),AllocNone );
      XtVaSetValues( Top,XtNcolormap,Cmap,NULL );
      continue;
    }

    if( strcmp( argv[i],"-graphic" ) == 0 ){
      GraphFile = argv[++i];
      continue;
    }

    if( strcmp( argv[i],"-help" ) == 0 ){
      help();
      exit(0);
    }
    fprintf(stderr,"%s: Unknown command line option \"%s\".\n",Myname,argv[i]);
    help();
    exit(1);
  }
}  


/* եåκɤ߹ */

static void make_graphic( void )
{
  int i;
  XpmAttributes attr;

  attr.valuemask = XpmColormap;
  attr.colormap = Cmap;

  if( GraphFile != NULL )
    i = XpmReadFileToPixmap( Disp,DefaultRootWindow(Disp),GraphFile,
			    &Char_p,&Char_m,&attr );
    else
      i = XpmCreatePixmapFromData( Disp,DefaultRootWindow(Disp),
				  picture_xpm,&Char_p,&Char_m,&attr );
  if( i ){
    fprintf( stderr,"%s: %s\n",Myname,XpmGetErrorString(i) );
    exit(1);
  }

  Gc_mask = XCreateGC( Disp,DefaultRootWindow(Disp),0,NULL );
  XSetClipMask( Disp,Gc_mask,Char_m );
}



/* Xlibط */

static int init_graph( void )
{
  int x,i;

  make_graphic();

  Gc_nomask = XCreateGC( Disp,DefaultRootWindow(Disp),0,NULL );

  Back_p = XCreatePixmap( Disp,DefaultRootWindow(Disp),
			 WIDTH*16,16,
			 DefaultDepth(Disp,DefaultScreen(Disp)) );
  XCopyArea( Disp,Char_p,Back_p,Gc_nomask,80,128,16,16,0,0 );
  XCopyArea( Disp,Char_p,Back_p,Gc_nomask,96,128,16,16,WIDTH*16-16,0 );
  for( x = 16 ; x < WIDTH*16-16 ; x+=16 )
    XCopyArea( Disp,Char_p,Back_p,Gc_nomask,0,128,16,16,x,0 );
  for( i = 0 ; i < 3 ; i++ ){
    Floor_p[i] = XCreatePixmap(Disp,DefaultRootWindow(Disp),
    				WIDTH*16-32,16,
    				DefaultDepth(Disp,DefaultScreen(Disp)));
    for( x = 0 ; x < WIDTH*16-32 ; x+=16 )
      XCopyArea(Disp,Char_p,Floor_p[i],Gc_nomask,i*16,128,16,16,x,0);
  }
  Floor_p[3] = XCreatePixmap(Disp,DefaultRootWindow(Disp),
   			WIDTH*16-32,16,
    			DefaultDepth(Disp,DefaultScreen(Disp)));
  for( x = 0 ; x < WIDTH*16-32 ; x+=32 )
    XCopyArea(Disp,Char_p,Floor_p[3],Gc_nomask,48,128,32,16,x,0);
}


/* ᥤ */

int main( int argc,char **argv )
{
  static XtActionsRec a_table[] = {
    {"start",  (XtActionProc)start_game},
    {"pause",  (XtActionProc)pause_game},
    {"quit",   (XtActionProc)quit_game},
    {"key_on", (XtActionProc)key_on},
    {"key_off",(XtActionProc)key_off},
    {"show",   (XtActionProc)show_record},
  };

  Widget game,w;
  int i;
  int uid,euid;

  if( (Myname = argv[0]) == NULL )
    Myname = "xjump";

  uid = getuid();
  euid = geteuid();
  seteuid(getuid());

  XtSetLanguageProc( NULL,NULL,NULL );

  Top = XtVaAppInitialize( &App,"XJumpX",NULL,0,
			  &argc,argv,DefaultResources,NULL );

  Disp = XtDisplay( Top );


  Cmap = DefaultColormap( Disp,DefaultScreen(Disp) );

  option( argc,argv );

  seteuid( euid );

  init_graph();

  game = XtVaCreateManagedWidget( "game",formWidgetClass,Top,NULL );

  XtVaCreateManagedWidget( "title",labelWidgetClass,game,NULL );
  XtVaCreateManagedWidget( "title2",labelWidgetClass,game,NULL );

  w = XtVaCreateManagedWidget( "scoreBoard",formWidgetClass,game,
			      NULL );

  XtVaCreateManagedWidget( "scLabel",labelWidgetClass,w,
			  NULL );

  Score = XtVaCreateManagedWidget( "score",labelWidgetClass,w,
				  XtNlabel,"000",
				  NULL );

  Gameover = XtVaCreateManagedWidget( "gameover",labelWidgetClass,game,
				     XtNmappedWhenManaged,FALSE,
				     NULL );

  Pause = XtVaCreateManagedWidget( "pause",labelWidgetClass,game,
				  XtNmappedWhenManaged,FALSE,
				  NULL );

  Scr = XtVaCreateManagedWidget( "scr",widgetClass,game,
				XtNwidth,WIDTH*16,
				XtNheight,HEIGHT*16,
				XtNmappedWhenManaged,FALSE,
				XtNbackgroundPixmap,Back_p,
				NULL );

  Score_v = XtVaCreateManagedWidget( "record_v",viewportWidgetClass,game,
				    XtNwidth,WIDTH*16,
				    XtNheight,HEIGHT*16,
				    NULL );

  ScoreList = XtVaCreateManagedWidget( "record",labelWidgetClass,Score_v,
				      XtNlabel,"",
				      NULL );

  Message = XtVaCreateManagedWidget( "message",labelWidgetClass,game,
				    XtNwidth,WIDTH*16,
				    XtNlabel, 
				        "space:start  Q:quit  r:show score",
				    NULL );

  XtVaCreateManagedWidget( "copyright",labelWidgetClass,game,NULL );

  XtAddEventHandler( Top,FocusChangeMask,FALSE,(XtEventHandler)focus,NULL );
#if 0
  XtAddEventHandler( Scr,ExposureMask,FALSE,(XtEventHandler)expose,NULL );
#endif

  XtAppAddActions( App,a_table,XtNumber(a_table) );

  if( signal( SIGINT,SIG_IGN ) != SIG_IGN )
    signal( SIGINT,sig_handler );

  if( signal( SIGTERM,SIG_IGN ) != SIG_IGN )
    signal( SIGTERM,sig_handler );

  XtRealizeWidget( Top );
  set_icon();
  Scr_d = XtWindow(Scr);

  PW_get_name(My_record.name,32,uid);
  My_record.uid = uid;

  Record.record_file = RECORD_FILE;
  Record.swap_file = SWAP_FILE;
  Record.lock_file = LOCK_FILE;
  Record.max_record = RECORD_ENTRY;
  Record.new_record = &My_record;
  Record.override = 1;

  sprintf(Filename[0],"%s/%d",RECORD_DIR,uid);
  sprintf(Filename[1],"%s/%d.swap",RECORD_DIR,uid);
  sprintf(Filename[2],"%s/%d.lock",RECORD_DIR,uid);
  Record_private.record_file = Filename[0];
  Record_private.swap_file = Filename[1];
  Record_private.lock_file = Filename[2];
  Record_private.max_record = RECORD_ENTRY_PRIVATE;
  Record_private.new_record = &My_record;
  Record_private.override = 0;

  if( RECORD_init(&Record) != -1 && RECORD_init(&Record_private) != -1 ){
    Recording = 1;
  }else{
    error();
    Recording = 0;
  }
  make_score();

  srnd(time(NULL));

  GameMode = TITLE;
  ScoreMode = SHOW_TOTAL;
  Key = 0;

  LOG_init();
  for( i =0 ; i < NUM_LOG ; i++ )
    Log[i].floor = 0;
  Log_cur = 0;

//  message("Push 'h' to show help.");

  XtAppMainLoop( App );

  return 0;
}
